=== debian/changelog ===
calligra (1:3.2.1+dfsg-9ubuntu1) oracular; urgency=medium

  * Build without okular odp/odt backends. Okular is now Qt6/KF6, so the
    backends are not buildable until we have the Qt6/KF6 port of
    calligra:
    - debian/control: Drop optional okular-dev build dependency.
    - debian/control: Do not ship oular-backend-odp and okular-backend-
      odt packages.
  * Update watch file as this release has been moved to 'Attic' on
    download.kde.org.

 -- Rik Mills <rikmills@kde.org>  Tue, 17 Sep 2024 08:01:49 +0100

calligra (1:3.2.1+dfsg-9) unstable; urgency=medium

  [ Pino Toscano ]
  * Add the configuration for the CI on salsa.
  * Switch the transitional pkg-config build dependency to pkgconf.
  * Bump Standards-Version to 4.7.0, no changes required.

  [ Andreas Hasenack ]
  * Add patch to fix build with poppler 24.06. (Closes: #1074386)

 -- Pino Toscano <pino@debian.org>  Mon, 19 Aug 2024 18:55:39 +0200
