=== debian/watch ===
version=4

opts=\
repacksuffix=+dfsg,\
dversionmangle=s/\+dfsg\d*$// \
 https://download.kde.org/Attic/calligra/([\d\.]+)/calligra-([\d\.]+)\.tar\.xz
